clear all
uqlab
rng(1)

%% UQLink Model 
% [.....Model obtained via uqlink, with 10 output.....]
% the quantities of interest are outputs 1 and 2
% myUQLinkModel = uq_createModel(zsoil_model);

%% Input
% InputOpts.Marginals(1).Name = 'E';
% InputOpts.Marginals(1).Type = 'Lognormal';
% InputOpts.Marginals(1).Moments = [8000 2000];
% InputOpts.Marginals(2).Name = 'c';
% InputOpts.Marginals(2).Type = 'Lognormal';
% InputOpts.Marginals(2).Moments = [10 2.5];
% myPriorInput = uq_createInput(InputOpts);

%%
%X_prior = uq_getSample(myPriorInput, 100, 'LHS');
%Y_prior = uq_evalModel(myUQLinkModel,X_prior);
load('100pts.mat')
% this file contains 100 samples, the model defined via UQlink, and the
% distribution 

%% PCK 
%the pck surrogates just the outputs 1 and 2

MetaOpts.Type = 'Metamodel';
MetaOpts.MetaType = 'PCK';
MetaOpts.Mode = 'sequential';
MetaOpts.Input = myPriorInput;
MetaOpts.ExpDesign.X = X_prior;
MetaOpts.ExpDesign.Y = Y_prior(: , 1:2);  
my_PCK = uq_createModel(MetaOpts);

%uq_print(my_PCK,1:2)

%% Bayesian Inversion
DiscrepancyOpts.Type = 'Gaussian';
DiscrepancyOpts.Parameters = 0.5 ; 

myData.y = [25 12] ; % measurements of output 1 and 2

Bayes.Type = 'Inversion';
Bayes.Data = myData;
Bayes.Prior = myPriorInput;
Bayes.ForwardModel = my_PCK;
Bayes.Discrepancy = DiscrepancyOpts ; 
myBayes = uq_createAnalysis(Bayes);

uq_print(myBayes)
uq_display(myBayes)

